//
// STIMUL - build_all.pas  -  ver 0.2
// OS Stimul Based on BSD License
//    STIMUL (C) Dubrovin Alexei 2008
//				   Target OS : Windows/Linux

Program Build_all;

uses strings
{$IFDEF WIN32}
	,crt,dos;
var patch_comp:String;
{$ENDIF}
{$IFDEF LINUX}
	,unix;
{$ENDIF}


var 
	k:longint;
	s:String;    f,r:text; rt:file of byte; _org:LongInt;  s_org:string;
	c:char;  incf:text;  fa,fb:file of byte; ddb:byte; gif:byte; iddb:DWord;
	sm_org:array[0..255] of dword; si_org:byte; ki_org:byte;
    confini:text;  coni:byte;  patch1,patch2:String; CompType:Boolean;

begin

// 1.  
     _org:=$20000;
     si_org:=0;
     sm_org[si_org]:=_org;
     coni:=0;
     
     assign(confini,'config.ini');
     {$I-}
      reset(confini); if (IOResult<>0) then begin  writeln('File config.ini not found!'); readln; exit; end;
     {$I+}
      while not eof(confini) do
      begin
        readln(confini,s_org);
        if (s_org<>'') and ((s_org[1]<>' ') and (s_org[1]<>'#')) then
        begin
            inc(coni);
            case coni of
               1 : patch1:=s_org;
               2 : patch2:=s_org;
               3 : if s_org='New' then CompType:=True else CompType:=False;
            end;
        end;
      end;
      s_org:='';
      close(confini);
      

     Writeln('This is the FIRST step of compilation OS STIMUL by Dubrovin Alexei!');
     Writeln;
     Writeln('For begining we are compling all Pascal files with FreePascal');
     writeln('wich needed for microkernel.');
  {$IFDEF WIN32}
     if patch1='' then patch_comp:='C:\pp\bin' else patch_comp:=patch1;
     patch_comp:=patch_comp+Patch2+'\';
  {$ENDIF}

      Writeln;
      Writeln('Reading services list (./kernel/services/list.inc)...          ');
      assign(f,'./kernel/services/list.inc');
      {$I-}
      reset(f); if (IOResult<>0) then begin writeln; writeln('File not found!... step aborted, press Enter for next step'); readln; exit; end;
      {$I+}
      readln(f);			//  
      readln(f);
      readln(f);
       while not eof(f) do
       begin
         readln(f,s);
  {$IFDEF WIN32}
         Exec(patch_comp+'fpc.exe','-Rintel -Us -ve .\kernel\services\'+s+'.pas');
  {$ENDIF}
  {$IFDEF LINUX}
	 Writeln('Compiling : /usr/bin/fpc -Rintel -Us -ve -Fokernel/services ./kernel/services/'+s+'.pas');
	 fpSystem('/usr/bin/fpc -Rintel -Us -ve -Fokernel/services ./kernel/services/'+s+'.pas');
  {$ENDIF}

         {assign(r,'./kernel/services/'+s+'.ppu');
         erase(r);
         }
	str(_org,s_org);
  {$IFDEF WIN32}
         Exec(patch_comp+'ld.exe','-e '+s_org+' -b ihex .\kernel\services\'+s+'.o -o .\kernel\services\'+s+'.ose');
  {$ENDIF}
  {$IFDEF LINUX}
	// Writeln('Linking...');
	Writeln('Linking : /usr/bin/ld -s -e '+s_org+' -b ihex -Tbss 0x20000 ./kernel/services/'+s+'.o -o ./kernel/services/'+s+'.ose');
	FpSystem('/usr/bin/ld -s -e'+s_org+' -b ihex -Tbss 0x20000 ./kernel/services/'+s+'.o -o ./kernel/services/'+s+'.ose');
	Writeln('Done');
  {$ENDIF}
         assign(rt,'./kernel/services/'+s+'.o');   {ose ???}
         reset(rt);
         _org:=_org+FileSize(rt);
         close(rt);
         inc(si_org);
         sm_org[si_org]:=_org;
       end;
      close(f);

      Writeln;
      Writeln;
      Writeln;

//  INC-   

  ki_org:=0;
 Writeln('It''s the second step of compilation OS STIMUL');
 Writeln('It may to analize OBJ-files of STIMUL services writen on');
 writeln('Free Pascal, make one big file of services and inc-file');
 writeln('for FASM whith local addreses of all services. It''s highly');
 writeln('needed for new STIMUL Kernel buid, if you modify old Pascal ');
 writeln('service data.');
 Writeln;
 if CompType then
 writeln('All services, which compliled early woud be destroy!!!');
 writeln;
 if CompType then
 begin
      writeln;
      Writeln;
      Writeln('Reading services list (/kernel/services/list.inc)...          ');
      assign(f,'./kernel/services/list.inc');
      {$I-}
      reset(f); if (IOResult<>0) then begin writeln; writeln('File not found!... step aborted, press Enter for next step'); readln; exit; end;
      {$I+}
      readln(f);
      readln(f);      readln(f);
      assign(incf,'./kernel/services/services.inc');
      rewrite(incf);
      writeln(incf,';This file was generated automaticaly in processing STIMUL build, please don''t edit it, if you don''t understand what you make');
      writeln(incf,';Thank you (C) STIMUL - BSD Based License');
      writeln(incf);
      assign(fb,'./kernel/services/services.col');
      rewrite(fb);
      while not eof(f) do
      begin
        readln(f,s);
        {$I-}
        assign(fa,'./kernel/services/'+s+'.o'); {?ose ????}
        reset(fa);
        if (IOResult<>0) then begin writeln; writeln('File ./kernel/services/'+s+'.ose not found!, but declared... service fail'); writeln(' Compilation aborted...'); exit; end;
        {$I+}
        
        gif:=0;
        iddb:=0;
        while not eof(fa) do
        begin
           read(fa,ddb);
           if (gif=0) and (ddb=$0) then begin  gif:=gif+1;end
           else if (gif=1) and (ddb=$ff) then gif:=gif+1
           else if (gif=2) and (ddb=$0f) then gif:=gif+1
           else if (gif=3) and (ddb=$fa) then gif:=gif+1
           else if (gif=4) and (ddb=$f0) then gif:=gif+1
           else if (gif=5) and (ddb=$af) then gif:=gif+1
           else if (gif=6) and (ddb=$aa) then gif:=gif+1
           else gif:=0;

	{$IFDEF WIN32}
           if (gif=7) then begin writeln(incf,s+' equ ',(sm_org[ki_org]+iddb+1-$20000)); end;
	{$ENDIF}
 	{$IFDEF LINUX}
	   if (gif=7) then begin writeln(incf,s+' equ ',(sm_org[ki_org]+iddb+1-$20000)); end;
	{$ENDIF}

           write(fb,ddb);
           inc(iddb);
        end;
         close(fa);
         writeln;
         writeln(s+'  [ Done ]');
         inc(ki_org);
      end;
      close(f);
      close(fb);
      close(incf);

      Writeln('Complite');
 end
 else
 writeln('Keep old services. Next Step ?!...');
 Writeln;
 Writeln;

{$IFDEF WIN32}
      Exec('.\fasm\fasm.exe','a.asm');          //   
      Exec('.\fasm\fasm.exe','setup.asm');      //   
      Exec('.\fasm\fasm.exe','kernel.asm');     //  
{$ENDIF}

{$IFDEF LINUX}
      fpSystem('./fasm/fasm a.asm');
      fpSystem('./fasm/fasm setup.asm');
      fpSystem('./fasm/fasm kernel.asm');
{$ENDIF}

//    STFS
{$IFDEF WIN32}
	Exec(patch_comp+'fpc.exe','crefs.pas');
{	Exec('crefs.exe','');   }
{$ENDIF}

{$IFDEF LINUX}
	fpSystem('/usr/bin/fpc crefs.pas');
	fpSystem('./crefs');
{$ENDIF}

//        -   :)      build.bat ( ??? )
(*{$IFDEF WIN32}
	Exec('copy','/b a.bin+setup.bin X.img');
	Exec('copy','/b X.img+b.img+c.img+d.img+kernel.bin+.\kernel\services\services.col a.img');
{$ENDIF}    *)

{$IFDEF LINUX}
	fpSystem('/bin/cat a.bin > X.img');
	fpSystem('/bin/cat setup.bin >> X.img');
	fpSystem('/bin/cat X.img > a.img');
	fpSystem('/bin/cat b.img >> a.img');
	fpSystem('/bin/cat c.img >> a.img');
	fpSystem('/bin/cat d.img >> a.img');
	fpSystem('/bin/cat kernel.bin >> a.img');
	fpSystem('/bin/cat ./kernel/services/services.col >> a.img');
{$ENDIF}

    writeln;
    Writeln('All Done !');
    {$IFDEF WIN32}
    Writeln('Please run build.bat now');
    {$ENDIF}
    Readln;
end.
