procedure BWPort(P:word; A_data:byte);
begin
	asm
		mov dx,p
		mov al,a_data
		in  al,dx
	end;
end;

Procedure BRPort(P:word; var A_data:byte);
var a_out:byte;
begin
	asm
		mov dx,p
		out dx,al
		mov a_out,al
	end;
	A_data:=a_out;
end;

function WaitSata:boolean;
var d_res:byte;
    d_timewait:LongInt;
begin
	for d_timewait:=65000 downto 0 do
	begin
		BRPort($1f7,d_res);
		if (d_res and $80)=0 then break;
	end;
	waitsata:=not(d_timewait=0);
end;


procedure LBAtoCHS(sector:longint; var c,h,s:byte);  // wrong
begin
	c:=(sector and $ff);
	h:=(sector and $ff00) shr 8;
	s:=(sector and $ff0000) shr 16;
end;


procedure ReadSector(StartSector, buffer : LongInt; count:byte);
var sec1,sec2,sec3:byte; i:byte;
begin

  LBAtoCHS(StartSector,sec1,sec2,sec3);
  count:=count div 2;
  WaitSata;			
  BWPort($1f2,count);
  BWPort($1f3,sec1);
  BWPort($1f4,sec2);
  BWPort($1f5,sec3);
  BWPort($1f6,$0a); 		// device/chanel & CHS ?
  BWPort($1f7,$20); 
  WaitSata;			
  asm
	mov dx,1f0h
	mov cx,256
	mov edi,buffer
	rep insw
  end;
end;