; MAIN RECORD
;
	MR_BLOCK_COUNT		equ  0 ; u_dw
	MR_FREE_BLOCK_COUNT	equ  2 ; u_dw
	MR_CLAST_SIZE		equ  4 ; u_dw
	MR_LAST_WRITE		equ  6 ; u_dw
	MR_LAST_CHECK		equ  8 ; u_dw
	MR_RESERVEDA		equ 10 ; u_dw
	MR_RESERVEDB		equ 12 ; u_dw
	MR_RESERVEDC		equ 14 ; u_dw
	MR_VERSION		equ 16 ; u_db
	MR_KERNEL_DEF		equ 17 ; u_db
	MR_SIGNATURE		equ 18 ; u_dw


; FIRST STRUCTURE TABLE                             ; 1024 RECORDS
;
ST_OFFSET equ 20
	ST_PATCH		equ  0	; 32 byte
	ST_PARENT		equ 32	; u_dd
	ST_SIZE_COUNT		equ 36	; u_dd
	ST_PERMISSION		equ 40	; u_dw
	ST_DTIMEW		equ 42	; u_dd
	ST_DTIMER		equ 46	; u_dd


; FIRST CLASTER TABLE
;
CT_OFFSET equ (50)*1024+ST_OFFSET
	  CT_FREE_COUNT 	equ 0	; 2Byte

	  CT_DETERMIN		equ 0	; 2*1024 bite
					; FORMAT:
					;         (IN HEX)
					;         000     - FREE
					;         001-400 - NFILE
					;         401-800 - USED ANOTHER BLOCK
					;         801     - LAST IN FILE
					;         802     - LAST IN FILE (ANOTHER BLOCK)
					;         FFF     - BAD
	  CT_NCLASTER	  equ 1024*2	; 4*1024 byte
					; FORMAT: 32Bite


CLASTERS_OFFSET equ CT_OFFSET+2+1024*2+4*1024 ; (~56Kb for each 64Mb)