; FOR VIDEO :

	mov	edi,memory_table
	mov	eax,video_page
next_mem_table:
	cmp	eax,bios_area
	je	exit_mem_table_cr
	stosd
	add	eax,1000h
	inc	ebx
	jmp	next_mem_table
exit_mem_table_cr:


; FOR EXTENDED RAM :

	mov	eax,first_page
next_ram_table:
	mov	byte [eax],'S'
	cmp	byte [eax],'S'
	jne	exit_ram_table_cr
	mov	byte [eax],0
	cmp	byte [eax],0
	jne	exit_ram_table_cr
	stosd
	add	eax,1000h
	inc	ebx
	jmp	next_ram_table
exit_ram_table_cr:

	mov	ebx,0b8000h
	mov	byte [ebx],'D'

						 ; ZERRO TO UNABLE MEMORY
	mov	eax,2h
zerro_mem_dir:
	cmp	edi,1000h
	jge	ex_zerro_mem_dir
	stosd
	jmp	zerro_mem_dir
ex_zerro_mem_dir:

	mov	ebx,0b8000h
	mov	byte [ebx],'O'

	xor	ecx,ecx
	mov	edi,page_directory	 ; PAGE DIRECTORY CREAT
	mov	eax,memory_table
next_page_dir_cr:
	cmp	ecx,ebx
	jge	exit_page_dir_cr
	stosd
	add	eax,1000h
	add	ecx,1000h
	jmp	next_page_dir_cr
exit_page_dir_cr:

	mov	ebx,0b8000h
	mov	byte [ebx],'K'

	sub	edi,4					      ; ZERRO TO UNABLE PAGE

	mov	eax,2h
zerro_pade_dir:
	cmp	edi,1000h
	je	ex_zerro_pade_dir
	stosd
	jmp	zerro_pade_dir
ex_zerro_pade_dir:








_exception:
;        in      al,61h                  ; beep
;        or      al,3
;        out     61h,al
	jmp	_exception		; hang
_irq0_7:
	push	eax
	mov	al,20h
	out	20h,al
	pop	eax
	iretd
_irq8_15:
	push	eax
	mov	al,20h
	out	0A1h,al
	pop	eax
	iretd
_int:
	in	al,61h			; beep
	or	al,3
	out	61h,al
	jmp	_int
	iretd

_irq1_hand:
	iretd


idt:
;  INT   00-07
   dw	 8 dup ( _int, CODE_SEL, int_access, 0)
;  INT   08 (irq 0)
   dw	 _irq0_7,CODE_SEL,int_access,0
;  INT   09 (irq1)
   dw	 _irq1_hand,CODE_SEL,int_access,0
;  INT   0A-0F (irq2-irq8)
   dw	 6 dup(_irq0_7,CODE_SEL,int_access,0)
;  INT   10F-6F
   dw	 97 dup(_int,CODE_SEL,int_access,0)
;  INT   70-78 (IRQ8-IRQ15)
   dw	 8 dup (_irq8_15,CODE_SEL,int_access,0)
;  INT   79-FF
   dw	 135 dup (_int,CODE_SEL,int_access,0)
idt_end:

idtr:
  dw idt_end - idt - 1
  dd idt+kernel_addr